//
//Basato sull'articolo del prof. Roberto Fantini
//Nuova Secondaria, n. 9, 2011, pag.94//
//
// Orbita di un pianeta (come la Terra) attorno al Sole
//
clear;
// prodotto GM in giorni^-2
GM=992;
// posizione iniziale della Terra in Giga metri
x0=152;
y0=0.;
// velocità iniziale della Terra  in Gm/giorno
vx0=0.;
vy0=2.53;
// passo in termini temporali (in unità di giorni)
delta_t=0.05;
// massa del Sole in unità di masse terrestri
M=333000.;
// costante di gravitazione universale in GM^3 giorno^-2 M^-1
G=0.00298;
// esponente nella legge di gravitazione Universale (default=2)
espo=2.;
// durata di un anno in giorni
anno=365.0;
// numero di step per coprire un anno (arrotondato per eccesso)
n_step=int(anno/delta_t+1);
print(%io(2),n_step);
// inizializza i vettori posizione e velocità
x(1)=x0;
y(1)=y0;
vx(1)=vx0;
vy(1)=vy0;
ax(1)=-GM*x(1)/x0^3;
ay(1)=-GM*y(1)/x0^3;
etot(1)=0.5*(vx0^2+vy0^2)-GM/sqrt(x0^2+y0^2);
t(1)=0.0;
for i=2:n_step
    t(i)=t(i-1)+delta_t;
    r=sqrt(x(i-1)*x(i-1)+y(i-1)*y(i-1));
    x(i)=x(i-1)+vx(i-1)*delta_t+0.5*ax(i-1)*delta_t^2;
    y(i)=y(i-1)+vy(i-1)*delta_t+0.5*ay(i-1)*delta_t^2;
    ax(i)=-GM*x(i)/r^3;
    ay(i)=-GM*y(i)/r^3;
    vx(i)=vx(i-1)+0.5*(ax(i)+ax(i-1))*delta_t;
    vy(i)=vy(i-1)+0.5*(ay(i-1)+ay(i))*delta_t;

    etot(i)=0.5*(vx(i)*vx(i)+vy(i)*vy(i))-GM/sqrt(x(i)*x(i)+y(i)*y(i));
//    print(%io(2),i,'(i4)');
end
// mette in grafico l'orbita ottenuta
xset("window",1);
plot2d(x,y);
xtitle('Orbita della Terra','x (Gm)',' y (Gm)');
// grafico dell'energia totale (cin+pot) per unità di massa della Terra
xset("window",2);
plot2d(t,etot);
xtitle('Orbita della Terra: energia totale','t (giorni)',' E_t /m');
flutt_etot=100.*st_deviation(etot)/mean(etot);
print(%io(2),flutt_etot);
c2=max(x)+min(x);
for i=1:n_step
    pf1=sqrt(x(i)*x(i)+y(i)*y(i));
    dx=x(i)-c2;
    pf2=sqrt(dx*dx+y(i)*y(i));
    ptot(i)=pf1+pf2;
end
// grafico della somma delle distanze dai 2 fuochi
xset("window",3);
xtitle('Orbita della Terra','t (giorni)','PF1+PF2');
plot2d(t,ptot);
flutt_ptot=100.*st_deviation(ptot)/mean(ptot);
print(%io(2),flutt_ptot);
c=c2/2.;
a=(max(x)-min(x))/2.;
b=sqrt(a^2-c^2);
n_fit=50;
for i=1:n_fit
    alfa=(i-1)*2.*%pi/(n_fit-1);
    x_fit(i)=a*cos(alfa)+c;
    y_fit(i)=b*sin(alfa);
end
// grafico di confronto tra l'orbita calcolata e un'ellisse con il fuoco nel Sole
xset("window",4);
X=[x;x_fit];
plot2d(x_fit,y_fit,-9);
plot2d(x,y);
xtitle('Orbita della Terra vs ellisse col Sole in F1','x (Gm)',' y (Gm)');
